/**************************************************************************

	Dwarf.dll version 1.1 (formerly deskmods.dll)

	Jeb Crouson (aka TrOgI)
	crouson@inreach.com
	http://lssource.cjb.net

/**************************************************************************
/*

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/
/****************************************************************************

8/31/99 - version 1.1
			fixed bug that caused LS to crash when using folders
			removed old bang commands that were replaced by toggles
			cleaned up some code - smaller size dll

7/18/99	- version 1.0
			fixed bug with folder items that use arguments not working
			added bang commands !DwarfToggleShow, !DwarfToggleTopmost, !DwarfToggleDrag
			added ability to dock dwarfs to the active window (thanks to dissipate for the idea)

6/3/99	- version 0.9
			fixed bug with subfolders not closing when folder closes
			Dwarfs are now draggable
			added DwarfEnableDrag option for step.rc
			added bang commands !DwarfEnableDrag and !DwarfDisableDrag

5/30/99	- version 0.8
			size parameters are back in
			added option of folders opening vertically and subfolders horizontally
			added Dwarf groups

5/28/99	- version 0.7
			Totally redone and renamed to Dwarf.dll
			Has folders and subfolders support
			hints are now supported
			Shortcuts and folders and subfolders have true transparency
			Added 4 bang commands
			Size parameters were removed
			
2/7/99	- version 0.6
			Fixed shortcut transparency and added optional size parameters.

2/3/99	- version 0.5
			Major tweak of the wharf.dll that allows you to put modules or shortcuts anywhere
			on the desktop. Does not have folders support or shortcut hints.


/****************************************************************************
 11/16/98 - Bug*Killer added by Fahim
			Added facility for popup menu to open when right clicked on wharf
			Divided the title bar in two parts : drag the left one to move the 
			bar, click on the right one to shade/unshade the bar. When the wharf
			bar is not shaded, a double click on the left part puts it in shaded
			mode & then moves it to a special position : 
			ScreenWidth - "WharfDblClickXPosition",0. When the wharf bar is 
			shaded, a double click on the left part unshades the bar, then docks
			it on the right, or on the left if the "WharfDblClickDockOnLeft" 
			step.rc entry is specified.
 11/15/98 - cael
			Added checks in SetWorkArea() to not change the work area if
			SetDesktopArea is true
 11/03/98 - W. Konkel
				Added the better wharf movement as well as sound to !WharfTasks
 11/02/98 - W. Konkel
				Added wharf open/close/min/max sounds (with the help/request 
					of snowchyld)
 11/01/98 - T. Engel
	 			Added back WharfTitleFont, WharfTitleFontSize, and a new
 				option WharfTitleFontWeight
 11/01/98 - W. Konkel
				Added better wharf movement (fixed a few small bugs)
				Made WharfCloseOnSwitch work much much better
 10/31/98 - Cyberian
				Fixed crashing on recycle when WharfCloseOnSwitch is enabled
 10/29/98 - Cyberian (Fahim Farook)
				Added WharfCloseOnSwitch to step.rc so that you can have the 
				subwharf folders auto-close when focus is lost if you desire
				Added support for wharf hints

 10/10/98 - W. Konkel
				Added snap-to-edge wharf and the ability to not include the
					default.bmp and 3dots.bmp in wharf layer.
 10/09/98 - C. Boyda
				Made the trans titlebar much more efficent in speed

 10/03/98 - J. Vaughn
				Added fully functional, working transparency to the wharf
				titlebar (why was it left out to begin with?? :P)

 09/03/98 - C. Boyda
                Added fully functional, working transparency to the wharf
            D. Hodgkiss
                Folders support is now in

 08/31/98 - D. Hodgkiss
                Added ability to move the wharf anywhere on the screen
                Added a titlebar to the wharf
                Added hide/unhide support

 08/25/98 - D. Hodgkiss
                This file contains the source for the wharf bar
 
****************************************************************************/

#include <windows.h>
#include <mmsystem.h>
#include <malloc.h>
#include <stdio.h>
#include <tchar.h>
#include <commctrl.h>
#include <stdlib.h>

#include "lsapi.h"
#include "dwarf.h"

// -------------------------------------------------------------------------------------------------------

const LPCTSTR   szMainWindowClass = _T("Dwarf");
const char rcsRevision[] = "$Revision: 1.1 $"; // Our Version 
const char rcsId[] = "$Id: dwarf.c,v 1.1 1999/08/31 TrOgI Exp $"; // The Full RCS ID.


FARPROC (__stdcall *SwitchToThisWindow)(HWND, int);

// our window procedure
LRESULT CALLBACK MainWndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam);

// -------------------------------------------------------------------------------------------------------

void DockToWindow(int i);
BOOL IsAppWindow(HWND hWnd);
void ToggleShow(HWND caller, char* arg);
void ToggleOnTop(HWND caller, char* arg);
void ToggleDrag(HWND caller, char* arg);
void CloseAllFolders();
void CloseSubFolders(int i);
void ExecuteWharf(int i);
void ExecuteSubWharf(int i, int x);
void ExecuteSubWharf2(int i, int x, int z);
BOOL CreateWharf(int i, LPCSTR);
BOOL CreateSubWharf(int i, int x, LPCSTR);
BOOL CreateSubWharf2(int i, int x, int z, LPCSTR);
BOOL PartOfWharf(HWND myWnd);
void ReadConfig(void);
int GetWharfByWnd(HWND hwnd);
void CreateWharfhints(HWND hWnd, char *txt, RECT *r);
void RemoveWharfhints(HWND hWnd);
char szLitestepPath[256];
char iniPath[256];
char lsPath[256];
char szImagePath[256];
char szDefPixmap[256];
char szFolderPixmap[256];
char dockPos[16];
int dockX = 0, dockY = 0;
int dockOffsetX = 0, dockOffsetY = 0;
long *p, *q;
RECT dockRect, oldRect;
HBITMAP defaultBackImage = NULL;
HBITMAP folderImage = NULL;
HBITMAP defaultFolderImage = NULL;
HINSTANCE dll;
HWND parent;
HWND desktop = NULL;
HWND wharfHints = NULL;
HWND activeWnd, oldWnd = NULL;
int ScreenWidth, ScreenHeight;
wharfType *wharfs = NULL;
int numWharfs = 0;
int wharfAnimTime;
int wharfStep = 64;
int OpenFolders = 0;
int OpenFolders2 = 0;
BOOL wharfNoAnim = FALSE;
BOOL wharfCloseOnSwitch = FALSE; 
BOOL showbg = TRUE;
BOOL wharfNoHints = TRUE;
BOOL wharfDrag = FALSE;
// -------------------------------------------------------------------------------------------------------
int initModule(HWND ParentWnd, HINSTANCE dllInst, wharfDataType* wd)
{
	return initModuleEx (ParentWnd, dllInst, wd->lsPath);
}

int initModuleEx(HWND ParentWnd, HINSTANCE dllInst, LPCSTR szPath)
{
	UINT Msgs[10];
	RECT r;
	int i, j;
	
	dll = dllInst;
	parent = ParentWnd;

	oldRect.bottom = 0;
	oldRect.left = 0;
	oldRect.right = 0;
	oldRect.top = 0;

	AddBangCommand("!DwarfToggleDrag", ToggleDrag);
	AddBangCommand("!DwarfToggleShow", ToggleShow);
	AddBangCommand("!DwarfToggleTopmost", ToggleOnTop);
	
	GetClientRect(GetDesktopWindow(),&r);
	ScreenWidth = GetSystemMetrics(SM_CXSCREEN);
	ScreenHeight = GetSystemMetrics(SM_CYSCREEN);

	desktop = FindWindow("DesktopBackgroundClass", NULL);
	if (!desktop)
		desktop = GetDesktopWindow();
	
	strcpy(szLitestepPath, szPath);
	strcpy(iniPath, szLitestepPath);
	if (iniPath[strlen(iniPath)] != '\\')
		strcat(iniPath, "\\");
	strcat(iniPath, "modules.ini");

	ReadConfig();
	if (!wharfNoHints) {
		wharfHints = CreateWindow
			(TOOLTIPS_CLASS,
			(LPSTR) NULL,
			TTS_ALWAYSTIP,
			CW_USEDEFAULT,
			CW_USEDEFAULT,
			CW_USEDEFAULT,
			CW_USEDEFAULT,
			NULL,
			(HMENU) NULL,
			dll,
			NULL
			);
		if (!wharfHints) {
			MessageBox(parent, "Error creating hints window", "Dwarf Hints Error", MB_OK);
			return 1;
		}
		SetWindowPos(wharfHints, HWND_TOPMOST,0,0,0,0,SWP_NOMOVE|SWP_NOSIZE|SWP_NOACTIVATE);
	}

	{	// Register our window class
		WNDCLASS wc;
		
		memset(&wc,0,sizeof(wc));
		wc.lpfnWndProc = MainWndProc;				  // our window procedure
		wc.hInstance = dllInst; 				// hInstance of DLL
		wc.lpszClassName = szMainWindowClass;	   // our window class name
		wc.style = CS_DBLCLKS;
		
		if (!RegisterClass(&wc)) 
		{
			MessageBox(parent,"Error registering window class", "Dwarf", MB_OK);
			return 1;
		}
	}
	
	SwitchToThisWindow = (FARPROC (__stdcall *)(HWND, int))GetProcAddress(GetModuleHandle("USER32.DLL"), "SwitchToThisWindow");

	{
		FILE *f;
		
		f = LCOpen (NULL);
		if (f)
		{
			char	buffer[4096];
			char	token1[4096], token2[4096], token3[4096], token4[4096], token5[4096], token6[4096], token7[4096], token8[4096], token9[4096], extra_text[4096];
			char*	tokens[9];
			BOOL	inFolder = FALSE;
			BOOL	inFolder2 = FALSE;

			tokens[0] = token1;
			tokens[1] = token2;
			tokens[2] = token3;
			tokens[3] = token4;
			tokens[4] = token5;
			tokens[5] = token6;
			tokens[6] = token7;
			tokens[7] = token8;
			tokens[8] = token9;

			buffer[0] = 0;

			while (LCReadNextConfig (f, "*Dwarf", buffer, sizeof (buffer)))
			{
				int count;
				
				token1[0] = token2[0] = token3[0] = token4[0] = token5[0] = token6[0] = token7[0] = token8[0] = token9[0] = extra_text[0] = '\0';
				
				count = LCTokenize (buffer, tokens, 9, extra_text);
				
				switch (count)
				{
				case 2:
					if (!strcmpi(token2, "~Folder"))
					{
						if(inFolder2 == FALSE)
						{
							inFolder = FALSE;
							numWharfs++;
						}
						else
						{
							inFolder2 = FALSE;
							wharfs[numWharfs].numSubwharfs++;
						}
						break;
					}
				case 4:
				case 5:
					{
						// token 1 is "*Dwarf", token 2 is the name, token 3 is the
						// graphic, token 4 is the executable, and token 5 are
						// the program arguments.
						char windowName[256];

						windowName[0] = '\0';

						strcpy (windowName, token4 + 1);

						if (inFolder)
						{
							if(inFolder2)
							{
								char szTT[1024];
								int w = numWharfs;
								int x = wharfs[w].numSubwharfs;
								int	z = wharfs[w].subwharfs[x].numSubwharfs;
							
								if (!wharfs[w].subwharfs[x].subwharfs2)
								{
									wharfs[w].subwharfs[x].subwharfs2 = (subwharf2Type *)malloc(sizeof(subwharf2Type));
								}
								else
								{
									wharfs[w].subwharfs[x].subwharfs2 = (subwharf2Type *)realloc(wharfs[w].subwharfs[x].subwharfs2, (z+1)*sizeof(subwharf2Type));
								}
								memset(&wharfs[w].subwharfs[x].subwharfs2[z], 0, sizeof(wharfs[w].subwharfs[x].subwharfs2[z]));
							
								if (token3[0] == '*')
								{
									char *temptoken3;
									temptoken3 = token3;
									if (*temptoken3 == '*')
										temptoken3++;
									strcpy(token3,temptoken3);
									wharfs[numWharfs].subwharfs[x].subwharfs2[z].showbg = FALSE;
								} 
								else 
								{
									wharfs[numWharfs].subwharfs[x].subwharfs2[z].showbg = TRUE;
								}
							
								strcpy (wharfs[w].subwharfs[x].subwharfs2[z].szName, token2);
								strcpy (wharfs[w].subwharfs[x].subwharfs2[z].szCommand, token4);
								strcpy (wharfs[w].subwharfs[x].subwharfs2[z].szParameters, token5);
								strcpy (szTT, token4);
								if (strnicmp(".extract", token3, 8) && token5 && strlen(token5))
								{
									strcat (szTT, " ");
									strcat (szTT, token5);
								}

								wharfs[w].subwharfs[x].subwharfs2[z].frontImage = LoadLSImage (token3, szTT);

								CreateSubWharf2(numWharfs, wharfs[w].numSubwharfs, wharfs[w].subwharfs[x].numSubwharfs, windowName);
								wharfs[w].subwharfs[x].numSubwharfs++;
							}
							else
							{
								char szTT[1024];
								int w = numWharfs;
								int x = wharfs[w].numSubwharfs;
							
								if (!wharfs[w].subwharfs)
								{
									wharfs[w].subwharfs = (subwharfType *)malloc(sizeof(subwharfType));
								}
								else
								{
									wharfs[w].subwharfs = (subwharfType *)realloc(wharfs[w].subwharfs, (x+1)*sizeof(subwharfType));
								}
								memset(&wharfs[w].subwharfs[x], 0, sizeof(wharfs[w].subwharfs[x]));
							
								if (token3[0] == '*')
								{
									char *temptoken3;
									temptoken3 = token3;
									if (*temptoken3 == '*')
										temptoken3++;
									strcpy(token3,temptoken3);
									wharfs[numWharfs].subwharfs[x].showbg = FALSE;
								} 
								else 
								{
									wharfs[numWharfs].subwharfs[x].showbg = TRUE;
								}
							
								strcpy (wharfs[w].subwharfs[x].szName, token2);
								strcpy (wharfs[w].subwharfs[x].szCommand, token4);
								strcpy (wharfs[w].subwharfs[x].szParameters, token5);

								if (!strcmpi (token4, "Folder"))
								{
									strcpy(szTT, token2);
								}
								else
								{	
									strcpy (szTT, token4);
									if (strnicmp(".extract", token3, 8) && token5 && strlen(token5))
									{
										strcat (szTT, " ");
										strcat (szTT, token5);
									}
								}
								wharfs[w].subwharfs[x].frontImage = LoadLSImage (token3, szTT);

								CreateSubWharf(numWharfs, wharfs[w].numSubwharfs, windowName);

								if (!strcmpi(token4, "Folder"))
								{
									inFolder2 = TRUE;
									wharfs[numWharfs].subwharfs[x].subwharfs2 = NULL;
									wharfs[numWharfs].subwharfs[x].numSubwharfs = 0;
									wharfs[numWharfs].subwharfs[x].subwharfOpen = FALSE;
									wharfs[numWharfs].subwharfs[x].hsubwharfWnd = CreateWindowEx(
										WS_EX_TOPMOST | WS_EX_TOOLWINDOW,
										szMainWindowClass,
										"",
										WS_CLIPCHILDREN | WS_POPUP,
										0, 0,
										0, 0,
										desktop,
										NULL,
										dll,
										NULL
										);
								
									SetWindowLong(wharfs[numWharfs].subwharfs[x].hsubwharfWnd, GWL_USERDATA, magicDWord);
									ShowWindow(wharfs[numWharfs].subwharfs[x].hsubwharfWnd, SW_SHOWNORMAL);
								}
								else
								{
									wharfs[w].numSubwharfs++;
								}
							}
						}
					}
					break;
				case 9:
					{
						// token 1 is "*Dwarf", token2 is the group/top status/hide status, token 3 is the name, 
						// token 4 is the x coordinate, token 5 is the y coordinate, token 6 is the graphic,
						// token 7 is the width, token 8 is the height, token 9 is the executable, 
						// and the extra_text are the program arguments.
						char windowName[256];
						char Xpos[10], Ypos[10], pos[64];

						windowName[0] = '\0';

						strcpy (windowName, token9 + 1);

						{
							char szTT[1024];

							if (!wharfs)
							{
								wharfs = (wharfType *)malloc(sizeof(wharfType));
							}
							else
							{
								wharfs = (wharfType *)realloc(wharfs, (numWharfs+1)*sizeof(wharfType));
							}
							memset(&wharfs[numWharfs], 0, sizeof(wharfs[numWharfs]));

							if (token6[0] == '*')
							{
								char *temptoken6;
								temptoken6 = token6;
								if (*temptoken6 == '*')
										temptoken6++;
								strcpy(token6,temptoken6);
								wharfs[numWharfs].showbg = FALSE;
							} 
							else 
							{
								wharfs[numWharfs].showbg = TRUE;
							}

							wharfs[numWharfs].group = 0;
							wharfs[numWharfs].onTop = FALSE;
							wharfs[numWharfs].visible = TRUE;
							wharfs[numWharfs].vertical = FALSE;
							wharfs[numWharfs].docked = FALSE;

							if(token2[0] == '#')
							{
								wharfs[numWharfs].group = atoi(&token2[1]);
								if(strstr(token2, "h") || strstr(token2, "H"))
									wharfs[numWharfs].visible = FALSE;
								if(strstr(token2, "t") || strstr(token2, "T"))
									wharfs[numWharfs].onTop = TRUE;
								if(strstr(token2, "v") || strstr(token2, "V"))
									wharfs[numWharfs].vertical = TRUE;
								if(strstr(token2, "d") || strstr(token2, "D"))
									wharfs[numWharfs].docked = TRUE;
							}
							strcpy(wharfs[numWharfs].szName, token3);

							GetPrivateProfileString("Dwarf", wharfs[numWharfs].szName, "NULL", &pos, sizeof(pos), iniPath);
							if(!strcmpi(pos, "NULL"))
							{
								wharfs[numWharfs].xPos = atoi(token4);
								wharfs[numWharfs].yPos = atoi(token5);
							}
							else
							{
								int i;
								for(i = 0; i < strlen(pos); i++)
								{
									if(pos[i] != '/')
										Xpos[i] = pos[i];
									else
									{
										i++;
										strcpy(Ypos, pos + i);
										i += 64;
									}
								}
								wharfs[numWharfs].xPos = atoi(Xpos);
								wharfs[numWharfs].yPos = atoi(Ypos);
							}
							if(wharfs[numWharfs].xPos < 0) wharfs[numWharfs].xPos += ScreenWidth;
							if(wharfs[numWharfs].yPos < 0) wharfs[numWharfs].yPos += ScreenHeight;
							wharfs[numWharfs].width = atoi(token7);
							wharfs[numWharfs].height = atoi(token8);
							strcpy(wharfs[numWharfs].szCommand, token9);
							strcpy(wharfs[numWharfs].szParameters, extra_text);

							if (!strcmpi (token9, "Folder"))
							{
								strcpy(szTT, token3);
							}
							else
							{
								strcpy(szTT, token9);
								if (strnicmp(".extract", token6, 8) && extra_text && strlen(extra_text))
								{
									strcat (szTT, " ");
									strcat (szTT, extra_text);
								}
							}
							wharfs[numWharfs].frontImage = LoadLSImage(token6, szTT);
							
							CreateWharf(numWharfs, windowName);
							
							if (!strcmpi(token9, "Folder"))
							{
								inFolder = TRUE;
								wharfs[numWharfs].subwharfs = NULL;
								wharfs[numWharfs].numSubwharfs = 0;
								wharfs[numWharfs].subwharfOpen = FALSE;
								wharfs[numWharfs].hsubwharfWnd = CreateWindowEx(
									WS_EX_TOPMOST | WS_EX_TOOLWINDOW,
									szMainWindowClass,
									"",
									WS_CLIPCHILDREN | WS_POPUP,
									0, 0,
									0, 0,
									desktop,
									NULL,
									dll,
									NULL
									);
								
								SetWindowLong(wharfs[numWharfs].hsubwharfWnd, GWL_USERDATA, magicDWord);
								ShowWindow(wharfs[numWharfs].hsubwharfWnd, SW_SHOWNORMAL);
							}
							else
							{
								numWharfs++;
							}
						}
					}
				}
			}
			LCClose(f);
		}
	}

	Msgs[0] = LM_GETREVID;
	Msgs[1] = 0;
	SendMessage(parent, LM_REGISTERMESSAGE, (WPARAM) wharfs[0].hWnd, (LPARAM) Msgs);

	for (i = 0; i < numWharfs; i++)
	{
		SetWindowRgn(wharfs[i].hWnd, wharfs[i].rgn, TRUE);
		wharfs[i].rgn = NULL;
		if (wharfs[i].hsubwharfWnd)
		{
			SetWindowRgn(wharfs[i].hsubwharfWnd, wharfs[i].subRgn, TRUE);
			wharfs[i].subRgn = NULL;
			for(j = 0; j < wharfs[i].numSubwharfs; j++)
			{
				if(wharfs[i].subwharfs[j].hsubwharfWnd)
				{
					SetWindowRgn(wharfs[i].subwharfs[j].hsubwharfWnd, wharfs[i].subwharfs[j].subRgn, TRUE);
					wharfs[i].subwharfs[j].subRgn = NULL;
				}
			}
		}
	}
	
	return 0;
}

// -------------------------------------------------------------------------------------------------------

LRESULT CALLBACK MainWndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	WORD fActive;
	HWND hwndGetFocus;

	switch(message)
	{
		case LM_GETREVID:
		{
			char *buf = (char *) lParam;

			if (wParam == 0)
			{
					strcpy(buf, "dwarf.dll: ");
					strcat(buf, &rcsRevision[11]);
					buf[strlen(buf)-1] = '\0';
			}
			else if (wParam == 1)
			{
				strcpy(buf, &rcsId[1]);
				buf[strlen(buf)-1] = '\0';
			} else
			{
				strcpy(buf, "");
			}
			return strlen(buf);

		}
	case WM_ENDSESSION:
	case WM_QUERYENDSESSION:
		return SendMessage(parent,message,wParam,lParam);
	case WM_SYSCOMMAND:
		{
			switch (wParam)
			{
			case SC_CLOSE:
				PostMessage(parent,WM_KEYDOWN,LM_SHUTDOWN,0);
				return 0;
			default:
				break;
			}
		}
		break;;

	case LM_RECYCLE:
		SendMessage(parent, message, wParam, lParam);
		return 0;

	case WM_TIMER:
		if (wParam == 2)   //sub wharf opening
		{
			int x, i = -1;

			for (x = 0; x < numWharfs; x++)
			{
				if (wharfs[x].hsubwharfWnd == hwnd)
				{
					i = x;
					break;
				}
			}
			if (i != -1) // subwharf positions
			{
				if (wharfs[i].closing) {
					KillTimer(wharfs[i].hsubwharfWnd, 2);
					SetTimer(wharfs[i].hsubwharfWnd, 3, wharfAnimTime, NULL);
				}
				else 
				{
					if(wharfs[i].vertical)
					{
						if (wharfs[i].movingPos + wharfStep >= wharfs[i].numSubwharfs*wharfs[i].height)
							wharfs[i].movingPos = wharfs[i].numSubwharfs*wharfs[i].height;
						else wharfs[i].movingPos += wharfStep;

						if ((wharfs[i].yPos+wharfs[i].height/2) > ScreenHeight/2)
						{
							SetWindowPos(wharfs[i].hsubwharfWnd, 0, wharfs[i].xPos, wharfs[i].yPos-wharfs[i].movingPos, wharfs[i].width, wharfs[i].movingPos, SWP_NOZORDER);
							if (wharfs[i].movingPos >= wharfs[i].numSubwharfs*wharfs[i].height)
							{
								wharfs[i].subwharfOpen = TRUE;
								wharfs[i].moving = FALSE;
								wharfs[i].closing = TRUE;
								KillTimer(wharfs[i].hsubwharfWnd, 2);
							}
						}
						else
						{
							SetWindowPos(wharfs[i].hsubwharfWnd, 0, wharfs[i].xPos, wharfs[i].yPos+wharfs[i].height, wharfs[i].width, wharfs[i].movingPos, SWP_NOZORDER);
							if (wharfs[i].movingPos >= wharfs[i].numSubwharfs*wharfs[i].height)
							{
								wharfs[i].subwharfOpen = TRUE;
								wharfs[i].moving = FALSE;
								wharfs[i].closing = TRUE;
								KillTimer(wharfs[i].hsubwharfWnd, 2);
							}
						}
					}
					else 
					{
						if (wharfs[i].movingPos + wharfStep >= wharfs[i].numSubwharfs*wharfs[i].width)
							wharfs[i].movingPos = wharfs[i].numSubwharfs*wharfs[i].width;
						else wharfs[i].movingPos += wharfStep;

						if ((wharfs[i].xPos+wharfs[i].width/2) > ScreenWidth/2)
						{
							SetWindowPos(wharfs[i].hsubwharfWnd, 0, wharfs[i].xPos-wharfs[i].movingPos, wharfs[i].yPos, wharfs[i].movingPos, wharfs[i].height, SWP_NOZORDER);
							if (wharfs[i].movingPos >= wharfs[i].numSubwharfs*wharfs[i].width)
							{
								wharfs[i].subwharfOpen = TRUE;
								wharfs[i].moving = FALSE;
								wharfs[i].closing = TRUE;
								KillTimer(wharfs[i].hsubwharfWnd, 2);
							}
						}
						else
						{
							SetWindowPos(wharfs[i].hsubwharfWnd, 0, wharfs[i].xPos+wharfs[i].width, wharfs[i].yPos, wharfs[i].movingPos, wharfs[i].height, SWP_NOZORDER);
							if (wharfs[i].movingPos >= wharfs[i].numSubwharfs*wharfs[i].width)
							{
								wharfs[i].subwharfOpen = TRUE;
								wharfs[i].moving = FALSE;
								wharfs[i].closing = TRUE;
								KillTimer(wharfs[i].hsubwharfWnd, 2);
							}
						}
					}
				}
			}
		}
		if (wParam == 3)  // sub wharf closing
		{
			int i;

			for (i = 0; i < numWharfs; i++)
			{
				if (wharfs[i].hsubwharfWnd == hwnd)
				{
					if (!wharfs[i].closing) {
						KillTimer(wharfs[i].hsubwharfWnd, 3);
						SetTimer(wharfs[i].hsubwharfWnd, 2, wharfAnimTime, NULL);
					}
					else {
						CloseSubFolders(i);
						wharfs[i].movingPos -= wharfStep;

						if(wharfs[i].vertical)
						{
							if ((wharfs[i].yPos+wharfs[i].height/2) > ScreenHeight/2)
							{
								SetWindowPos(wharfs[i].hsubwharfWnd, 0, wharfs[i].xPos, wharfs[i].yPos-wharfs[i].movingPos, wharfs[i].width, wharfs[i].movingPos, SWP_NOZORDER);
								if (wharfs[i].movingPos <= 0)
								{
									wharfs[i].subwharfOpen = FALSE;
									wharfs[i].moving = FALSE;
									wharfs[i].closing = FALSE;
									KillTimer(wharfs[i].hsubwharfWnd, 3);
								}
							}
							else
							{
								SetWindowPos(wharfs[i].hsubwharfWnd, 0, wharfs[i].xPos, wharfs[i].yPos+wharfs[i].height, wharfs[i].width, wharfs[i].movingPos, SWP_NOZORDER);
								if (wharfs[i].movingPos <= 0)
								{
									wharfs[i].subwharfOpen = FALSE;
									wharfs[i].moving = FALSE;
									wharfs[i].closing = FALSE;
									KillTimer(wharfs[i].hsubwharfWnd, 3);
								}
							}
						}
						else
						{
							if ((wharfs[i].xPos+wharfs[i].width/2) > ScreenWidth/2)
							{
								SetWindowPos(wharfs[i].hsubwharfWnd, 0, wharfs[i].xPos-wharfs[i].movingPos, wharfs[i].yPos, wharfs[i].movingPos, wharfs[i].height, SWP_NOZORDER);
								if (wharfs[i].movingPos <= 0)
								{
									wharfs[i].subwharfOpen = FALSE;
									wharfs[i].moving = FALSE;
									wharfs[i].closing = FALSE;
									KillTimer(wharfs[i].hsubwharfWnd, 3);
								}
							}
							else
							{
								SetWindowPos(wharfs[i].hsubwharfWnd, 0, wharfs[i].xPos+wharfs[i].width, wharfs[i].yPos, wharfs[i].movingPos, wharfs[i].height, SWP_NOZORDER);
								if (wharfs[i].movingPos <= 0)
								{
									wharfs[i].subwharfOpen = FALSE;
									wharfs[i].moving = FALSE;
									wharfs[i].closing = FALSE;
									KillTimer(wharfs[i].hsubwharfWnd, 3);
								}
							}
						}
					}
				}
			}
		}
		if (wParam == 5)   //subwharf2 opening
		{
			int x, z, i = -1, j = -1;

			for (x = 0; x < numWharfs; x++)
			{
				for(z = 0; z < wharfs[x].numSubwharfs; z++)
				{
					if (wharfs[x].subwharfs[z].hsubwharfWnd == hwnd)
					{
						i = x;
						j = z;
						break;
					}
				}
			}
			if (i != -1 && j != -1) // subwharf2 positions
			{
				if (wharfs[i].subwharfs[j].closing) {
					KillTimer(wharfs[i].subwharfs[j].hsubwharfWnd, 5);
					SetTimer(wharfs[i].subwharfs[j].hsubwharfWnd, 6, wharfAnimTime, NULL);
				}
				else 
				{
					if(wharfs[i].vertical)
					{
						if (wharfs[i].subwharfs[j].movingPos + wharfStep >= wharfs[i].subwharfs[j].numSubwharfs*wharfs[i].width )
							wharfs[i].subwharfs[j].movingPos = wharfs[i].subwharfs[j].numSubwharfs*wharfs[i].width;
						else wharfs[i].subwharfs[j].movingPos += wharfStep;

						if ((wharfs[i].xPos+wharfs[i].width/2) > ScreenWidth/2)
						{
							if((wharfs[i].yPos+wharfs[i].height/2) > ScreenHeight/2)
								SetWindowPos(wharfs[i].subwharfs[j].hsubwharfWnd, 0, wharfs[i].xPos-wharfs[i].subwharfs[j].movingPos, wharfs[i].yPos-((wharfs[i].numSubwharfs-j)*wharfs[i].height), wharfs[i].subwharfs[j].movingPos, wharfs[i].height, SWP_NOZORDER);
							else
								SetWindowPos(wharfs[i].subwharfs[j].hsubwharfWnd, 0, wharfs[i].xPos-wharfs[i].subwharfs[j].movingPos, wharfs[i].yPos+((j+1)*wharfs[i].height), wharfs[i].subwharfs[j].movingPos, wharfs[i].height, SWP_NOZORDER);
							if (wharfs[i].subwharfs[j].movingPos >= wharfs[i].subwharfs[j].numSubwharfs*wharfs[i].width)
							{
								wharfs[i].subwharfs[j].subwharfOpen = TRUE;
								wharfs[i].subwharfs[j].moving = FALSE;
								wharfs[i].subwharfs[j].closing = TRUE;
								KillTimer(wharfs[i].subwharfs[j].hsubwharfWnd, 5);
							}
						}
						else
						{
							if((wharfs[i].yPos+wharfs[i].height/2) > ScreenHeight/2)
								SetWindowPos(wharfs[i].subwharfs[j].hsubwharfWnd, 0, wharfs[i].xPos+wharfs[i].width, wharfs[i].yPos-((wharfs[i].numSubwharfs-j)*wharfs[i].height), wharfs[i].subwharfs[j].movingPos, wharfs[i].height, SWP_NOZORDER);
							else
								SetWindowPos(wharfs[i].subwharfs[j].hsubwharfWnd, 0, wharfs[i].xPos+wharfs[i].width, wharfs[i].yPos+((j+1)*wharfs[i].height), wharfs[i].subwharfs[j].movingPos, wharfs[i].height, SWP_NOZORDER);
							if (wharfs[i].subwharfs[j].movingPos >= wharfs[i].subwharfs[j].numSubwharfs*wharfs[i].width)
							{
								wharfs[i].subwharfs[j].subwharfOpen = TRUE;
								wharfs[i].subwharfs[j].moving = FALSE;
								wharfs[i].subwharfs[j].closing = TRUE;
								KillTimer(wharfs[i].subwharfs[j].hsubwharfWnd, 5);
							}
						}
					}
					else
					{
						if (wharfs[i].subwharfs[j].movingPos + wharfStep >= wharfs[i].subwharfs[j].numSubwharfs*wharfs[i].height )
							wharfs[i].subwharfs[j].movingPos = wharfs[i].subwharfs[j].numSubwharfs*wharfs[i].height;
						else wharfs[i].subwharfs[j].movingPos += wharfStep;

						if ((wharfs[i].xPos+wharfs[i].width/2) > ScreenWidth/2)
						{
							if((wharfs[i].yPos+wharfs[i].height/2) > ScreenHeight/2)
								SetWindowPos(wharfs[i].subwharfs[j].hsubwharfWnd, 0, wharfs[i].xPos-((wharfs[i].numSubwharfs-j)*wharfs[i].width), wharfs[i].yPos-wharfs[i].subwharfs[j].movingPos, wharfs[i].width, wharfs[i].subwharfs[j].movingPos, SWP_NOZORDER);
							else
								SetWindowPos(wharfs[i].subwharfs[j].hsubwharfWnd, 0, wharfs[i].xPos-((wharfs[i].numSubwharfs-j)*wharfs[i].width), wharfs[i].yPos+wharfs[i].height, wharfs[i].width, wharfs[i].subwharfs[j].movingPos, SWP_NOZORDER);
							if (wharfs[i].subwharfs[j].movingPos >= wharfs[i].subwharfs[j].numSubwharfs*wharfs[i].height)
							{
								wharfs[i].subwharfs[j].subwharfOpen = TRUE;
								wharfs[i].subwharfs[j].moving = FALSE;
								wharfs[i].subwharfs[j].closing = TRUE;
								KillTimer(wharfs[i].subwharfs[j].hsubwharfWnd, 5);
							}
						}
						else
						{
							if((wharfs[i].yPos+wharfs[i].height/2) > ScreenHeight/2)
								SetWindowPos(wharfs[i].subwharfs[j].hsubwharfWnd, 0, wharfs[i].xPos+((j+1)*wharfs[i].width), wharfs[i].yPos-wharfs[i].subwharfs[j].movingPos, wharfs[i].width, wharfs[i].subwharfs[j].movingPos, SWP_NOZORDER);
							else
								SetWindowPos(wharfs[i].subwharfs[j].hsubwharfWnd, 0, wharfs[i].xPos+((j+1)*wharfs[i].width), wharfs[i].yPos+wharfs[i].height, wharfs[i].width, wharfs[i].subwharfs[j].movingPos, SWP_NOZORDER);
							if (wharfs[i].subwharfs[j].movingPos >= wharfs[i].subwharfs[j].numSubwharfs*wharfs[i].height)
							{
								wharfs[i].subwharfs[j].subwharfOpen = TRUE;
								wharfs[i].subwharfs[j].moving = FALSE;
								wharfs[i].subwharfs[j].closing = TRUE;
								KillTimer(wharfs[i].subwharfs[j].hsubwharfWnd, 5);
							}
						}
					}
				}
			}
		}
		if (wParam == 6)  // subwharf2 closing
		{
			int i, j;

			for (i = 0; i < numWharfs; i++)
			{
				for(j = 0; j < wharfs[i].numSubwharfs; j++)
				{
					if (wharfs[i].subwharfs[j].hsubwharfWnd == hwnd)
					{
						if (!wharfs[i].subwharfs[j].closing) {
							KillTimer(wharfs[i].subwharfs[j].hsubwharfWnd, 6);
							SetTimer(wharfs[i].subwharfs[j].hsubwharfWnd, 5, wharfAnimTime, NULL);
						}
						else 
						{
							wharfs[i].subwharfs[j].movingPos -= wharfStep;

							if(wharfs[i].vertical)
							{
								if ((wharfs[i].xPos+wharfs[i].width/2) > ScreenWidth/2)
								{
									if((wharfs[i].yPos+wharfs[i].height/2) > ScreenHeight/2)
										SetWindowPos(wharfs[i].subwharfs[j].hsubwharfWnd, 0, wharfs[i].xPos-wharfs[i].subwharfs[j].movingPos, wharfs[i].yPos-((wharfs[i].numSubwharfs-j)*wharfs[i].height), wharfs[i].subwharfs[j].movingPos, wharfs[i].height, SWP_NOZORDER);
									else
										SetWindowPos(wharfs[i].subwharfs[j].hsubwharfWnd, 0, wharfs[i].xPos-wharfs[i].subwharfs[j].movingPos, wharfs[i].yPos+((j+1)*wharfs[i].height), wharfs[i].subwharfs[j].movingPos, wharfs[i].height, SWP_NOZORDER);
									if (wharfs[i].subwharfs[j].movingPos <= 0)
									{
										wharfs[i].subwharfs[j].subwharfOpen = FALSE;
										wharfs[i].subwharfs[j].moving = FALSE;
										wharfs[i].subwharfs[j].closing = FALSE;
										KillTimer(wharfs[i].subwharfs[j].hsubwharfWnd, 6);
									}
								}
								else
								{
									if((wharfs[i].yPos+wharfs[i].height/2) > ScreenHeight/2)
										SetWindowPos(wharfs[i].subwharfs[j].hsubwharfWnd, 0, wharfs[i].xPos+wharfs[i].width, wharfs[i].yPos-((wharfs[i].numSubwharfs-j)*wharfs[i].height), wharfs[i].subwharfs[j].movingPos, wharfs[i].height, SWP_NOZORDER);
									else
										SetWindowPos(wharfs[i].subwharfs[j].hsubwharfWnd, 0, wharfs[i].xPos+wharfs[i].width, wharfs[i].yPos+((j+1)*wharfs[i].height), wharfs[i].subwharfs[j].movingPos, wharfs[i].height, SWP_NOZORDER);
									if (wharfs[i].subwharfs[j].movingPos <= 0)
									{
										wharfs[i].subwharfs[j].subwharfOpen = FALSE;
										wharfs[i].subwharfs[j].moving = FALSE;
										wharfs[i].subwharfs[j].closing = FALSE;
										KillTimer(wharfs[i].subwharfs[j].hsubwharfWnd, 6);
									}
								}
							}
							else
							{
								if ((wharfs[i].xPos+wharfs[i].width/2) > ScreenWidth/2)
								{
									if((wharfs[i].yPos+wharfs[i].height/2) > ScreenHeight/2)
										SetWindowPos(wharfs[i].subwharfs[j].hsubwharfWnd, 0, wharfs[i].xPos-((wharfs[i].numSubwharfs-j)*wharfs[i].width), wharfs[i].yPos-wharfs[i].subwharfs[j].movingPos, wharfs[i].width, wharfs[i].subwharfs[j].movingPos, SWP_NOZORDER);
									else
										SetWindowPos(wharfs[i].subwharfs[j].hsubwharfWnd, 0, wharfs[i].xPos-((wharfs[i].numSubwharfs-j)*wharfs[i].width), wharfs[i].yPos+wharfs[i].height, wharfs[i].width, wharfs[i].subwharfs[j].movingPos, SWP_NOZORDER);
									if (wharfs[i].subwharfs[j].movingPos <= 0)
									{
										wharfs[i].subwharfs[j].subwharfOpen = FALSE;
										wharfs[i].subwharfs[j].moving = FALSE;
										wharfs[i].subwharfs[j].closing = FALSE;
										KillTimer(wharfs[i].subwharfs[j].hsubwharfWnd, 6);
									}
								}
								else
								{
									if((wharfs[i].yPos+wharfs[i].height/2) > ScreenHeight/2)
										SetWindowPos(wharfs[i].subwharfs[j].hsubwharfWnd, 0, wharfs[i].xPos+((j+1)*wharfs[i].width), wharfs[i].yPos-wharfs[i].subwharfs[j].movingPos, wharfs[i].width, wharfs[i].subwharfs[j].movingPos, SWP_NOZORDER);
									else
										SetWindowPos(wharfs[i].subwharfs[j].hsubwharfWnd, 0, wharfs[i].xPos+((j+1)*wharfs[i].width), wharfs[i].yPos+wharfs[i].height, wharfs[i].width, wharfs[i].subwharfs[j].movingPos, SWP_NOZORDER);
									if (wharfs[i].subwharfs[j].movingPos <= 0)
									{
										wharfs[i].subwharfs[j].subwharfOpen = FALSE;
										wharfs[i].subwharfs[j].moving = FALSE;
										wharfs[i].subwharfs[j].closing = FALSE;
										KillTimer(wharfs[i].subwharfs[j].hsubwharfWnd, 6);
									}
								}
							}
						}
					}
				}
			}
		}
		if (wParam == 8)
		{
			int i;

			activeWnd = GetForegroundWindow();
			GetWindowRect(activeWnd, &dockRect);

			if(activeWnd != oldWnd || oldRect.bottom != dockRect.bottom 
				|| oldRect.left != dockRect.left || oldRect.right != dockRect.right
				|| oldRect.top != dockRect.top)
			{
				for (i = 0; i < numWharfs; i++)
				{
					if (wharfs[i].docked)
					{
						DockToWindow(i);
					}
				}

				oldWnd = activeWnd;
				oldRect.bottom = dockRect.bottom;
				oldRect.left = dockRect.left;
				oldRect.right = dockRect.right;
				oldRect.top = dockRect.top;
			}
		}
		return 0;

	case WM_CREATE: return 0;
	case WM_ERASEBKGND: return 0;
		
	case WM_PAINT:
		{
			int i = GetWharfByWnd(hwnd);
			PAINTSTRUCT ps;
			HDC src = CreateCompatibleDC(NULL);
			HDC hdc = BeginPaint(hwnd,&ps);
			
			if (i != -1)
			{
				if (wharfs[i].backImage)
				{
					SelectObject(src, wharfs[i].backImage);
					BitBlt(hdc, 0, 0, wharfs[i].width, wharfs[i].height, src, 0, 0, SRCCOPY);
				}
			} else {
				int x, y, z;
				
				for (x = 0; x < numWharfs; x++)
				{
					if (wharfs[x].subwharfs)
					{
						for (y = 0; y < wharfs[x].numSubwharfs; y++)
						{
							if (hwnd == wharfs[x].subwharfs[y].hWnd)
							{
								if (wharfs[x].subwharfs[y].backImage)
								{
									SelectObject(src, wharfs[x].subwharfs[y].backImage);
									BitBlt(hdc, 0, 0, wharfs[x].width, wharfs[x].height, src, 0, 0, SRCCOPY);
								}
							}
							else
							{
								if(wharfs[x].subwharfs[y].subwharfs2)
								{
									for(z = 0; z < wharfs[x].subwharfs[y].numSubwharfs; z++)
									{
										if(hwnd == wharfs[x].subwharfs[y].subwharfs2[z].hWnd)
										{
											if(wharfs[x].subwharfs[y].subwharfs2[z].backImage)
											{
												SelectObject(src, wharfs[x].subwharfs[y].subwharfs2[z].backImage);
												BitBlt(hdc, 0, 0, wharfs[x].width, wharfs[x].height, src, 0, 0, SRCCOPY);
											}
										}
									}
								}
							}
						}
					}
				}
			}
			EndPaint(hwnd,&ps);
			DeleteDC(src);
			
		}
		return 0;

	case WM_LBUTTONDOWN:
		return 0;
	case WM_LBUTTONUP:
		{
			int i = GetWharfByWnd(hwnd);
			
			if (i != -1)
			{
				ExecuteWharf(i);
			} else {
				int x, y, z;
				for (x = 0; x < numWharfs; x++)
				{
					if (wharfs[x].subwharfs)
					{
						for (y = 0; y < wharfs[x].numSubwharfs; y++)
						{
							if (hwnd == wharfs[x].subwharfs[y].hWnd)
							{
								ExecuteSubWharf(x, y);
							
								return 0;
							}
							else
							{
								if(wharfs[x].subwharfs[y].subwharfs2)
								{
									for(z = 0; z < wharfs[x].subwharfs[y].numSubwharfs; z++)
									{
										if(hwnd == wharfs[x].subwharfs[y].subwharfs2[z].hWnd)
										{
											ExecuteSubWharf2(x, y, z);
											
										}
									}
								}
							}
						}
					}
				}
			}
		}
		return 0;
	case WM_RBUTTONUP: // Open popup menu
            SendMessage(parent, LM_POPUP, (int)HIWORD(lParam), (int)LOWORD(lParam));
            return 0;
    case WM_RBUTTONDOWN: // Close popup menu
		{
            SendMessage(parent, LM_HIDEPOPUP, (int)HIWORD(lParam), (int)LOWORD(lParam));
			if(wharfDrag)
				SendMessage(hwnd, WM_SYSCOMMAND, SC_MOVE | 2, lParam);
		}
		return 0;

	case WM_MOUSEMOVE:
		{
			MSG TooltipMessage;

			int i = GetWharfByWnd(hwnd);

			if (!wharfNoHints) {
				if (i >= 0) {
					TooltipMessage.hwnd=wharfs[i].hWnd;
					TooltipMessage.message=message;
					TooltipMessage.wParam=wParam;
					TooltipMessage.lParam=lParam;
					SendMessage(wharfHints,TTM_RELAYEVENT,0,(LPARAM)&TooltipMessage);
					SetWindowPos(wharfHints, HWND_TOPMOST,0,0,0,0,SWP_NOMOVE|SWP_NOSIZE|SWP_NOACTIVATE);
				}
			}		
		}
		return 0;

	case WM_MOVE:
		{
			char Xpos[10], Ypos[10], pos[64];
			int i = GetWharfByWnd(hwnd);
			if (i == -1) return 0;

			wharfs[i].xPos = LOWORD(lParam);
			wharfs[i].yPos = HIWORD(lParam);

			itoa(wharfs[i].xPos, Xpos, 10);
			itoa(wharfs[i].yPos, Ypos, 10);
			strcpy(pos, Xpos);
			strcat(pos, "/");
			strcat(pos, Ypos);
			
			WritePrivateProfileString("Dwarf", wharfs[i].szName, pos, iniPath);
		}
		return 0;

	case WM_PARENTNOTIFY:
		{
			if(LOWORD(wParam) == WM_RBUTTONDOWN && wharfDrag)
				SendMessage(hwnd, WM_SYSCOMMAND, SC_MOVE | 2, lParam);
		}
		return 0;

	case WM_ACTIVATE:
		if (wharfCloseOnSwitch) {
			fActive = LOWORD(wParam);
			hwndGetFocus = (HWND)lParam;
			
    		if(fActive == WA_INACTIVE)
    		{
				if (!PartOfWharf(hwndGetFocus))	CloseAllFolders();
			}
		}
	}
	return DefWindowProc(hwnd,message,wParam,lParam);
}


BOOL PartOfWharf(HWND myWnd)
{
	int i,j,k;
	if (myWnd == NULL) return FALSE;
	if (parent == myWnd) return TRUE;
	
	for (i=0;i<numWharfs;i++) if (wharfs[i].hWnd == myWnd) return TRUE;
	for (i=0;i<numWharfs;i++) if (wharfs[i].hsubwharfWnd == myWnd) return TRUE;
		
	for (i = 0; i < numWharfs; i++) {
		for (j=0; j < wharfs[i].numSubwharfs; j++)
		{
			if(myWnd == wharfs[i].subwharfs[j].hWnd)
				return TRUE;
			if(myWnd == wharfs[i].subwharfs[j].hsubwharfWnd)
				return TRUE;
			for(k=0; k < wharfs[i].subwharfs[j].numSubwharfs; k++)
				if(myWnd == wharfs[i].subwharfs[j].subwharfs2[k].hWnd)
					return TRUE;
		}
	}
		
	return FALSE;
}

// -------------------------------------------------------------------------------------------------------
// cleanup (opposite of init()). Destroys the window, unregisters the window class
void quitModule(HINSTANCE dllInst) {
	RECT deskRect;
	int i;
	
	if (!wharfNoHints) {
		if (wharfHints) {
			DestroyWindow (wharfHints);
			wharfHints = NULL;
		}
	}
	for (i = 0; i < numWharfs; i++) 
	{
		if (wharfs[i].subwharfs) 
		{
			int x;
			for (x = 0; x < wharfs[i].numSubwharfs; x++) 
			{
				if(wharfs[i].subwharfs[x].subwharfs2)
				{
					int z;
					for(z = 0; z < wharfs[i].subwharfs[x].numSubwharfs; z++)
					{
						if(wharfs[i].subwharfs[x].subwharfs2[z].hInst)
						{
							(*wharfs[i].subwharfs[x].subwharfs2[z].quitWharfModule)(wharfs[i].subwharfs[x].subwharfs2[z].hInst);
							FreeLibrary(wharfs[i].subwharfs[x].subwharfs2[z].hInst);
						}
						DestroyWindow(wharfs[i].subwharfs[x].subwharfs2[z].hWnd);
						if (wharfs[i].subwharfs[x].subwharfs2[z].backImage)
							DeleteObject(wharfs[i].subwharfs[x].subwharfs2[z].backImage);
						if (wharfs[i].subwharfs[x].subwharfs2[z].frontImage)
							DeleteObject(wharfs[i].subwharfs[x].subwharfs2[z].frontImage);
					}
					free(wharfs[i].subwharfs[x].subwharfs2);
				}
				if(wharfs[i].subwharfs[x].hsubwharfWnd)
					DestroyWindow(wharfs[i].subwharfs[x].hsubwharfWnd);
				if(wharfs[i].subwharfs[x].subRgn)
					DeleteObject(wharfs[i].subwharfs[x].subRgn);
				if (wharfs[i].subwharfs[x].hInst) 
				{
					(*wharfs[i].subwharfs[x].quitWharfModule)(wharfs[i].subwharfs[x].hInst);
					FreeLibrary(wharfs[i].subwharfs[x].hInst);
				}
				DestroyWindow(wharfs[i].subwharfs[x].hWnd);
				if (wharfs[i].subwharfs[x].backImage)
					DeleteObject(wharfs[i].subwharfs[x].backImage);
				if (wharfs[i].subwharfs[x].frontImage)
					DeleteObject(wharfs[i].subwharfs[x].frontImage);
			}
			free(wharfs[i].subwharfs);
		}
		if (wharfs[i].hsubwharfWnd)
			DestroyWindow(wharfs[i].hsubwharfWnd);
		if (wharfs[i].subRgn)
			DeleteObject(wharfs[i].subRgn);
		if (wharfs[i].hInst) 
		{
			(*wharfs[i].quitWharfModule)(wharfs[i].hInst);
			FreeLibrary(wharfs[i].hInst);
		}
		DestroyWindow(wharfs[i].hWnd);
		if (wharfs[i].backImage)
			DeleteObject(wharfs[i].backImage);
		if (wharfs[i].frontImage)
			DeleteObject(wharfs[i].frontImage);
		if(wharfs[i].docked)
			KillTimer(wharfs[i].hWnd, 8);
	}
	free(wharfs);
	
	if (defaultBackImage)
		DeleteObject(defaultBackImage);
	if (folderImage)
		DeleteObject(folderImage);
	if (defaultFolderImage)
		DeleteObject(defaultFolderImage);

	UnregisterClass(szMainWindowClass,dllInst); // unregister window class
}

void ReadConfig (void)
{
	char szToken[256];

	wharfNoAnim = GetRCBool("DwarfNoAnim", TRUE);
	wharfStep = GetRCInt("DwarfAnimStep", 64);
	wharfAnimTime = GetRCInt("DwarfAnimDelay", 10); 
	wharfNoHints = GetRCBool("DwarfNoHints", TRUE);
	wharfCloseOnSwitch = GetRCBool("DwarfCloseOnSwitch", TRUE);
	wharfDrag = GetRCBool("DwarfEnableDrag", TRUE);
	dockOffsetX = GetRCInt("DwarfDockOffsetX", 0);
	dockOffsetY = GetRCInt("DwarfDockOffsetY", 0);

	GetRCString("PixmapPath", szImagePath, "c:\\litestep\\images\\", 256);
	GetRCString("DwarfDockPosition", dockPos, "LT", 16);
	if (GetRCString("DwarfBackPic", szDefPixmap, "", 256))
	{
		defaultBackImage = LoadLSImage (szDefPixmap, NULL);
	}

	if (GetRCString("DwarfFolderBackPic", szFolderPixmap, "", 256))
	{
		defaultFolderImage = LoadLSImage (szFolderPixmap, NULL);
	}

	if (GetRCString("DwarfFolderPic", szToken, "", 256))
	{
		folderImage = LoadLSImage (szToken, NULL);
	}
}

void CloseAllFolders()
{
	__try {
		int i, j;
		
		for (i = 0; i < numWharfs; i++)
		{
			if (wharfs[i].subwharfOpen || wharfs[i].moving)
			{
				for(j = 0; j < wharfs[i].numSubwharfs; j++)
				{
					if(wharfs[i].subwharfs[j].subwharfOpen || wharfs[i].subwharfs[j].moving)
					{
						if (wharfNoAnim)
						{
							SetWindowPos(wharfs[i].subwharfs[j].hsubwharfWnd, 0, 0, 0, 0, 0, SWP_NOZORDER);
							wharfs[i].subwharfs[j].subwharfOpen = FALSE;
						} else{
							wharfs[i].subwharfs[j].moving = TRUE;
							wharfs[i].subwharfs[j].closing = TRUE;
							SetTimer(wharfs[i].subwharfs[j].hsubwharfWnd, 6, wharfAnimTime, NULL);
						}
						OpenFolders2--;
					}
				}
				if (wharfNoAnim)
				{
					SetWindowPos(wharfs[i].hsubwharfWnd, 0, 0, 0, 0, 0, SWP_NOZORDER);
					wharfs[i].subwharfOpen = FALSE;
				} else{
					wharfs[i].moving = TRUE;
					wharfs[i].closing = TRUE;
					SetTimer(wharfs[i].hsubwharfWnd, 3, wharfAnimTime, NULL);
				}
				OpenFolders--;
			}
		}
	} __except(GetExceptionCode()==EXCEPTION_ACCESS_VIOLATION) {};
}

void CloseSubFolders(int i)
{
	__try {
		int j;
		
		for (j = 0; j < wharfs[i].numSubwharfs; j++)
		{
			if (wharfs[i].subwharfs[j].subwharfOpen || wharfs[i].subwharfs[j].moving)
			{
				if (wharfNoAnim)
				{
					SetWindowPos(wharfs[i].subwharfs[j].hsubwharfWnd, 0, 0, 0, 0, 0, SWP_NOZORDER);
					wharfs[i].subwharfs[j].subwharfOpen = FALSE;
				} else{
					wharfs[i].subwharfs[j].moving = TRUE;
					wharfs[i].subwharfs[j].closing = TRUE;
					SetTimer(wharfs[i].subwharfs[j].hsubwharfWnd, 6, wharfAnimTime, NULL);
				}
				OpenFolders2--;
			}
		}
	} __except(GetExceptionCode()==EXCEPTION_ACCESS_VIOLATION) {};
}

BOOL CreateWharf(int i, LPCSTR szWindowName)
{
	HWND hWnd = NULL;
	RECT r;

	hWnd = CreateWindowEx(
		WS_EX_TOOLWINDOW,
		szMainWindowClass,
		szWindowName,
		WS_POPUP,
		0, 0,
		wharfs[i].width, wharfs[i].height,
		desktop,
		NULL,
		dll,
		NULL);
	
	if (!hWnd)
	{
		MessageBox(parent, "Error creating Dwarf tile", "Dwarf", MB_OK);
		return FALSE;
	}
	wharfs[i].hWnd = hWnd;
	SetWindowLong(wharfs[i].hWnd, GWL_USERDATA, magicDWord);
//Wharf hints
	if (!wharfNoHints) {
		if (hWnd) {
			RECT r;
			GetClientRect (hWnd, &r);
			CreateWharfhints (hWnd, wharfs[i].szName, &r);
		}
	}
	if(wharfs[i].onTop)
		SetWindowPos(wharfs[i].hWnd, HWND_TOPMOST, wharfs[i].xPos, wharfs[i].yPos, 0, 0, SWP_NOSIZE);
	else
		SetWindowPos(wharfs[i].hWnd, 0, wharfs[i].xPos, wharfs[i].yPos, 0, 0, SWP_NOZORDER|SWP_NOSIZE);

	if(wharfs[i].docked)
	{
		if(!strcmpi(strlwr(dockPos), "tbl"))
		{
			wharfs[i].dockPoint.x = dockX;
			wharfs[i].dockPoint.y = 0;
			p = &dockRect.left;
			q = &dockRect.top;
		}
		else if(!strcmpi(strlwr(dockPos), "tbr"))
		{
			wharfs[i].dockPoint.x = 0 - dockX -wharfs[i].width;
			wharfs[i].dockPoint.y = 0;
			p = &dockRect.right;
			q = &dockRect.top;
		}
		else if(!strcmpi(strlwr(dockPos), "tl"))
		{
			wharfs[i].dockPoint.x = dockX;
			wharfs[i].dockPoint.y = 0 - wharfs[i].height;
			p = &dockRect.left;
			q = &dockRect.top;
		}
		else if(!strcmpi(strlwr(dockPos), "tr"))
		{
			wharfs[i].dockPoint.x = 0 - dockX - wharfs[i].width;
			wharfs[i].dockPoint.y = 0 - wharfs[i].height;
			p = &dockRect.right;
			q = &dockRect.top;
		}
		else if(!strcmpi(strlwr(dockPos), "bl"))
		{
			wharfs[i].dockPoint.x = dockX;
			wharfs[i].dockPoint.y = 0;
			p = &dockRect.left;
			q = &dockRect.bottom;
		}
		else if(!strcmpi(strlwr(dockPos), "br"))
		{
			wharfs[i].dockPoint.x = 0 - dockX - wharfs[i].width;
			wharfs[i].dockPoint.y = 0;
			p = &dockRect.right;
			q = &dockRect.bottom;
		}
		else if(!strcmpi(strlwr(dockPos), "rt"))
		{
			wharfs[i].dockPoint.x = 0;
			wharfs[i].dockPoint.y = dockY;
			p = &dockRect.right;
			q = &dockRect.top;
		}
		else if(!strcmpi(strlwr(dockPos), "rb"))
		{
			wharfs[i].dockPoint.x = 0;
			wharfs[i].dockPoint.y = 0 - dockY - wharfs[i].height;
			p = &dockRect.right;
			q = &dockRect.bottom;
		}
		else if(!strcmpi(strlwr(dockPos), "lb"))
		{
			wharfs[i].dockPoint.x = 0 - wharfs[i].width;
			wharfs[i].dockPoint.y = 0 - dockY - wharfs[i].height;
			p = &dockRect.left;
			q = &dockRect.bottom;
		}
		else
		{
			wharfs[i].dockPoint.x = 0 - wharfs[i].width;
			wharfs[i].dockPoint.y = dockY;
			p = &dockRect.left;
			q = &dockRect.top;
		}

		DockToWindow(i);
		if(dockX == 0)
		{
			SetTimer(wharfs[i].hWnd, 8, 1000, NULL);
		}
		dockX += wharfs[i].width;
		dockY += wharfs[i].height;
	}

	if (wharfs[i].szCommand[0] == '@')
	{
		int (FAR *FinitWharfModule)(HWND, HINSTANCE, wharfDataType*);
		int (FAR *FquitWharfModule)(HINSTANCE);
		HRGN (FAR *FGetLSRegion)(int, int);

		char *module;
		HINSTANCE moduleInst;
		
		module = wharfs[i].szCommand;
		if (*module == '@')
			module++;
		moduleInst = LoadLibrary(module);
		if ((UINT)moduleInst > HINSTANCE_ERROR)
		{
			FinitWharfModule = (int (FAR *)(HWND, HINSTANCE, wharfDataType*))GetProcAddress(moduleInst, "initWharfModule");
			FquitWharfModule = (int (FAR *)(HINSTANCE))GetProcAddress(moduleInst, "quitWharfModule");
			FGetLSRegion = (HRGN (FAR *)(int, int))GetProcAddress(moduleInst, "GetLSRegion");

			if (!FinitWharfModule || !FquitWharfModule)
			{
				MessageBox(NULL, module, "Invalid Dwarf module", MB_OK);
				FreeLibrary(moduleInst);
				wharfs[i].hInst = NULL;
			} else {
				wharfs[i].hInst = moduleInst;
				wharfs[i].initWharfModule = FinitWharfModule;
				wharfs[i].quitWharfModule = FquitWharfModule;
				wharfs[i].GetLSRegion = FGetLSRegion;
				ExecuteWharf(i);
			}
		} else {
			wharfs[i].hInst = NULL;
			MessageBox(NULL, module, "Error loading module", MB_OK);
		}
	}
	
	/* Combine our images into one */
	{
		HDC src = CreateCompatibleDC(NULL);
		HDC dst = CreateCompatibleDC(NULL);
		HBRUSH hb = CreateSolidBrush(RGB(255,0,255));
		HDC tempDC = GetDC(wharfs[i].hWnd);
		RECT r;
		
		wharfs[i].backImage = CreateCompatibleBitmap(tempDC, wharfs[i].width, wharfs[i].height);
		SelectObject(dst, wharfs[i].backImage);
		r.left = 0;
		r.top = 0;
		r.right = wharfs[i].width;
		r.bottom = wharfs[i].height;
		FillRect(dst, &r, hb);

		if (wharfs[i].hInst && !wharfs[i].GetLSRegion)
		{
			HDC ddc = GetDC(GetDesktopWindow());
			POINT p;

			p.x = 0;
			p.y = 0;
			ClientToScreen(wharfs[i].hWnd, &p);
			BitBlt(dst, 0, 0, wharfs[i].width, wharfs[i].height, ddc, p.x, p.y, SRCCOPY);

			ReleaseDC(GetDesktopWindow(), ddc);

		}
		if (defaultBackImage)
		{
		
			if ( wharfs[i].showbg == TRUE ) 
			{
				SelectObject(src, defaultBackImage);
				TransparentBltLS(dst, 0, 0, wharfs[i].width, wharfs[i].height, src, 0, 0, RGB(255, 0, 255));
			}
		}
		if (wharfs[i].frontImage)
		{
			BITMAP bmInfo;
			
			GetObject(wharfs[i].frontImage, sizeof(bmInfo), &bmInfo);
			if (bmInfo.bmWidth > wharfs[i].width) bmInfo.bmWidth = wharfs[i].width;
			if (bmInfo.bmHeight > wharfs[i].height) bmInfo.bmHeight = wharfs[i].height;
			SelectObject(src, wharfs[i].frontImage);
			TransparentBltLS(dst, (wharfs[i].width/2)-(bmInfo.bmWidth/2), (wharfs[i].height/2)-(bmInfo.bmHeight/2), bmInfo.bmWidth, bmInfo.bmHeight, src, 0, 0, RGB(255,0,255));
			DeleteObject(wharfs[i].frontImage);
		}
		if ((folderImage) && (!strcmpi(wharfs[i].szCommand, "Folder")))
		{
			if ( wharfs[i].showbg == TRUE ) 
			{
				SelectObject(src, folderImage);
				TransparentBltLS(dst, 0, 0, wharfs[i].width, wharfs[i].height, src, 0, 0, RGB(255,0,255));
			}
		}
		
		ReleaseDC(wharfs[i].hWnd, tempDC);
		DeleteDC(src);
		DeleteDC(dst);
		DeleteObject(hb);
	}
	
	/* Calculate transparent regions for hMainWnd here, compile regions per bitmap/tile and add together
	* for a full transparent parent window - <toasty@iav.com>  */
	
	if (wharfs[i].backImage && !wharfs[i].hInst)
	{
		wharfs[i].rgn = BitmapToRegion(wharfs[i].backImage, RGB(255,0,255), 0x101010, 0, 0);
	}
	else
	{
		HRGN rgn;
		if (wharfs[i].GetLSRegion)
		{
			HRGN bgRgn = BitmapToRegion(wharfs[i].backImage, RGB(255,0,255), 0x101010, 0, 0);
			if (rgn = wharfs[i].GetLSRegion(0, 0))
			{
				CombineRgn(rgn, rgn, bgRgn, RGN_OR);
				DeleteObject(bgRgn);
			}
			else
			{
				rgn = bgRgn;
			}
		}
		else
		{
			rgn = CreateRectRgn(0, 0, wharfs[i].width, wharfs[i].height);
		}
		
		CombineRgn(wharfs[i].rgn, wharfs[i].rgn, rgn, RGN_OR);
		
		DeleteObject(rgn);
	}
	
	if(wharfs[i].visible)
		ShowWindow(wharfs[i].hWnd, SW_SHOWNORMAL);
	else
		ShowWindow(wharfs[i].hWnd, SW_HIDE);
	GetClientRect(wharfs[i].hWnd, &r);
	InvalidateRect(wharfs[i].hWnd, &r, TRUE);
	
	return TRUE;
}

BOOL CreateSubWharf(int i, int x, LPCSTR szWindowName)
{
	HWND hWnd = NULL;
	
	hWnd = CreateWindowEx(
		0,
		szMainWindowClass,
		szWindowName,
		WS_CHILD,
		0, 0,
		wharfs[i].width, wharfs[i].height,
		wharfs[i].hsubwharfWnd,
		NULL,
		dll,
		NULL);
	
	wharfs[i].subwharfs[x].hWnd = hWnd;
	SetWindowLong(wharfs[i].subwharfs[x].hWnd, GWL_USERDATA, magicDWord);
//Wharf hints
	if (!wharfNoHints) {
		if (hWnd) {
			RECT r;
			GetClientRect (hWnd, &r);
			CreateWharfhints (hWnd, wharfs[i].subwharfs[x].szName, &r);
		}
	}

	if(wharfs[i].vertical)
		SetWindowPos(wharfs[i].subwharfs[x].hWnd, 0, 0, x*wharfs[i].height, 0, 0, SWP_NOZORDER|SWP_NOSIZE);
	else
		SetWindowPos(wharfs[i].subwharfs[x].hWnd, 0, x*wharfs[i].width, 0, 0, 0, SWP_NOZORDER|SWP_NOSIZE);
	
	if (wharfs[i].subwharfs[x].szCommand[0] == '@')
	{
		int (FAR *FinitWharfModule)(HWND, HINSTANCE, wharfDataType*);
		int (FAR *FquitWharfModule)(HINSTANCE);
		HRGN (FAR *FGetLSRegion)(int, int);

		char *module;
		HINSTANCE moduleInst;
		
		module = wharfs[i].subwharfs[x].szCommand;
		if (*module == '@')
			module++;
		moduleInst = LoadLibrary(module);
		if ((UINT)moduleInst > HINSTANCE_ERROR)
		{
			FinitWharfModule = (int (FAR *)(HWND, HINSTANCE, wharfDataType*))GetProcAddress(moduleInst, "initWharfModule");
			FquitWharfModule = (int (FAR *)(HINSTANCE))GetProcAddress(moduleInst, "quitWharfModule");
			FGetLSRegion = (HRGN (FAR *)(int, int))GetProcAddress(moduleInst, "GetLSRegion");

			if (!FinitWharfModule || !FquitWharfModule)
			{
				MessageBox(NULL, module, "Invalid Dwarf module", MB_OK);
				FreeLibrary(moduleInst);
				wharfs[i].subwharfs[x].hInst = NULL;
			} else {
				wharfs[i].subwharfs[x].hInst = moduleInst;
				wharfs[i].subwharfs[x].initWharfModule = FinitWharfModule;
				wharfs[i].subwharfs[x].quitWharfModule = FquitWharfModule;
				wharfs[i].subwharfs[x].GetLSRegion = FGetLSRegion;
				ExecuteSubWharf(i, x);
			}
		} else {
			wharfs[i].subwharfs[x].hInst = NULL;
			MessageBox(NULL, module, "Error loading module", MB_OK);
		}
	}
	
	/* Combine our images into one */
	{
		HDC src = CreateCompatibleDC(NULL);
		HDC dst = CreateCompatibleDC(NULL);
		HDC tempDC = GetDC(wharfs[i].subwharfs[x].hWnd);
		HBRUSH hb = CreateSolidBrush(RGB(255,0,255));
		RECT r;
		
		wharfs[i].subwharfs[x].backImage = CreateCompatibleBitmap(tempDC, wharfs[i].width, wharfs[i].height);
		SelectObject(dst, wharfs[i].subwharfs[x].backImage);
		r.left = 0;
		r.top = 0;
		r.right = wharfs[i].width;
		r.bottom = wharfs[i].height;
		FillRect(dst, &r, hb);
		
		if (defaultFolderImage)
		{
			if ( wharfs[i].subwharfs[x].showbg == TRUE ) 
			{
				SelectObject(src, defaultFolderImage);
				BitBlt(dst, 0, 0, wharfs[i].width, wharfs[i].height, src, 0, 0, SRCCOPY);
			}
		}
		if (wharfs[i].subwharfs[x].frontImage)
		{
			BITMAP bmInfo;
			
			GetObject(wharfs[i].subwharfs[x].frontImage, sizeof(bmInfo), &bmInfo);
			if (bmInfo.bmWidth > wharfs[i].width) bmInfo.bmWidth = wharfs[i].width;
			if (bmInfo.bmHeight > wharfs[i].height) bmInfo.bmHeight = wharfs[i].height;
			SelectObject(src, wharfs[i].subwharfs[x].frontImage);
			TransparentBltLS(dst, (wharfs[i].width/2)-(bmInfo.bmWidth/2), (wharfs[i].height/2)-(bmInfo.bmHeight/2), bmInfo.bmWidth, bmInfo.bmHeight, src, 0, 0, RGB(255,0,255));
			DeleteObject(wharfs[i].subwharfs[x].frontImage);
		}
		if ((folderImage) && (!strcmpi(wharfs[i].subwharfs[x].szCommand, "Folder")))
		{
			if ( wharfs[i].subwharfs[x].showbg == TRUE ) 
			{
				SelectObject(src, folderImage);
				TransparentBltLS(dst, 0, 0, wharfs[i].width, wharfs[i].height, src, 0, 0, RGB(255,0,255));
			}
		}
		
		ReleaseDC(wharfs[i].subwharfs[x].hWnd, tempDC);
		DeleteDC(src);
		DeleteDC(dst);
		DeleteObject(hb);
	}
	
	if (wharfs[i].subwharfs[x].backImage && !wharfs[i].subwharfs[x].hInst)
	{
		HRGN wharfRgn;
		
		if(wharfs[i].vertical)
			wharfRgn = BitmapToRegion(wharfs[i].subwharfs[x].backImage, RGB(255,0,255), 0x101010, 0, (wharfs[i].height*x));
		else
			wharfRgn = BitmapToRegion(wharfs[i].subwharfs[x].backImage, RGB(255,0,255), 0x101010, (wharfs[i].width*x), 0);
		
		if (CombineRgn(wharfs[i].subRgn, wharfs[i].subRgn, wharfRgn, RGN_OR) == ERROR)
			wharfs[i].subRgn = wharfRgn;
		else
			DeleteObject(wharfRgn);
	}
	else
	{
		HRGN rgn, bgRgn;
		if (wharfs[i].subwharfs[x].GetLSRegion)
		{
			if(wharfs[i].vertical)
			{
				bgRgn = BitmapToRegion(wharfs[i].subwharfs[x].backImage, RGB(255,0,255), 0x101010, 0, (wharfs[i].height*x));
				rgn = wharfs[i].subwharfs[x].GetLSRegion(0, wharfs[i].height*x);
			}
			else
			{
				bgRgn = BitmapToRegion(wharfs[i].subwharfs[x].backImage, RGB(255,0,255), 0x101010, (wharfs[i].width*x), 0);
				rgn = wharfs[i].subwharfs[x].GetLSRegion(wharfs[i].width*x, 0);
			}
			if (rgn)
			{
				CombineRgn(rgn, rgn, bgRgn, RGN_OR);
				DeleteObject(bgRgn);
			}
			else
			{
				rgn = bgRgn;
			}

		}
		else
		{
			if(wharfs[i].vertical)
				rgn = CreateRectRgn(0, wharfs[i].height*x, wharfs[i].width, wharfs[i].height*(x+1));
			else
				rgn = CreateRectRgn(wharfs[i].width*x, 0, wharfs[i].width*(x+1), wharfs[i].height);
		}
		
		if (CombineRgn(wharfs[i].subRgn, wharfs[i].subRgn, rgn, RGN_OR) == ERROR)
			wharfs[i].subRgn = rgn;
		else
			DeleteObject(rgn);
	}
	
	ShowWindow(wharfs[i].subwharfs[x].hWnd, SW_SHOWNORMAL);
	
	return TRUE;
}

BOOL CreateSubWharf2(int i, int x, int z, LPCSTR szWindowName)
{
	HWND hWnd = NULL;
	
	hWnd = CreateWindowEx(
		0,
		szMainWindowClass,
		szWindowName,
		WS_CHILD,
		0, 0,
		wharfs[i].width, wharfs[i].height,
		wharfs[i].subwharfs[x].hsubwharfWnd,
		NULL,
		dll,
		NULL);
	
	wharfs[i].subwharfs[x].subwharfs2[z].hWnd = hWnd;
	SetWindowLong(wharfs[i].subwharfs[x].subwharfs2[z].hWnd, GWL_USERDATA, magicDWord);
//Wharf hints
	if (!wharfNoHints) {
		if (hWnd) {
			RECT r;
			GetClientRect (hWnd, &r);
			CreateWharfhints (hWnd, wharfs[i].subwharfs[x].subwharfs2[z].szName, &r);
		}
	}

	if(wharfs[i].vertical)
		SetWindowPos(wharfs[i].subwharfs[x].subwharfs2[z].hWnd, 0, z*wharfs[i].width, 0, 0, 0, SWP_NOZORDER|SWP_NOSIZE);
	else
		SetWindowPos(wharfs[i].subwharfs[x].subwharfs2[z].hWnd, 0, 0, z*wharfs[i].height, 0, 0, SWP_NOZORDER|SWP_NOSIZE);
	
	if (wharfs[i].subwharfs[x].subwharfs2[z].szCommand[0] == '@')
	{
		int (FAR *FinitWharfModule)(HWND, HINSTANCE, wharfDataType*);
		int (FAR *FquitWharfModule)(HINSTANCE);
		HRGN (FAR *FGetLSRegion)(int, int);

		char *module;
		HINSTANCE moduleInst;
		
		module = wharfs[i].subwharfs[x].subwharfs2[z].szCommand;
		if (*module == '@')
			module++;
		moduleInst = LoadLibrary(module);
		if ((UINT)moduleInst > HINSTANCE_ERROR)
		{
			FinitWharfModule = (int (FAR *)(HWND, HINSTANCE, wharfDataType*))GetProcAddress(moduleInst, "initWharfModule");
			FquitWharfModule = (int (FAR *)(HINSTANCE))GetProcAddress(moduleInst, "quitWharfModule");
			FGetLSRegion = (HRGN (FAR *)(int, int))GetProcAddress(moduleInst, "GetLSRegion");

			if (!FinitWharfModule || !FquitWharfModule)
			{
				MessageBox(NULL, module, "Invalid Dwarf module", MB_OK);
				FreeLibrary(moduleInst);
				wharfs[i].subwharfs[x].subwharfs2[z].hInst = NULL;
			} else {
				wharfs[i].subwharfs[x].subwharfs2[z].hInst = moduleInst;
				wharfs[i].subwharfs[x].subwharfs2[z].initWharfModule = FinitWharfModule;
				wharfs[i].subwharfs[x].subwharfs2[z].quitWharfModule = FquitWharfModule;
				wharfs[i].subwharfs[x].subwharfs2[z].GetLSRegion = FGetLSRegion;
				ExecuteSubWharf2(i, x, z);
			}
		} else {
			wharfs[i].subwharfs[x].subwharfs2[z].hInst = NULL;
			MessageBox(NULL, module, "Error loading module", MB_OK);
		}
	}
	
	/* Combine our images into one */
	{
		HDC src = CreateCompatibleDC(NULL);
		HDC dst = CreateCompatibleDC(NULL);
		HDC tempDC = GetDC(wharfs[i].subwharfs[x].subwharfs2[z].hWnd);
		HBRUSH hb = CreateSolidBrush(RGB(255,0,255));
		RECT r;
		
		wharfs[i].subwharfs[x].subwharfs2[z].backImage = CreateCompatibleBitmap(tempDC, wharfs[i].width, wharfs[i].height);
		SelectObject(dst, wharfs[i].subwharfs[x].subwharfs2[z].backImage);
		r.left = 0;
		r.top = 0;
		r.right = wharfs[i].width;
		r.bottom = wharfs[i].height;
		FillRect(dst, &r, hb);
		
		if (defaultFolderImage)
		{
			if ( wharfs[i].subwharfs[x].subwharfs2[z].showbg == TRUE ) 
			{
				SelectObject(src, defaultFolderImage);
				BitBlt(dst, 0, 0, wharfs[i].width, wharfs[i].height, src, 0, 0, SRCCOPY);
			}
		}
		if (wharfs[i].subwharfs[x].subwharfs2[z].frontImage)
		{
			BITMAP bmInfo;
			
			GetObject(wharfs[i].subwharfs[x].subwharfs2[z].frontImage, sizeof(bmInfo), &bmInfo);
			if (bmInfo.bmWidth > wharfs[i].width) bmInfo.bmWidth = wharfs[i].width;
			if (bmInfo.bmHeight > wharfs[i].height) bmInfo.bmHeight = wharfs[i].height;
			SelectObject(src, wharfs[i].subwharfs[x].subwharfs2[z].frontImage);
			TransparentBltLS(dst, (wharfs[i].width/2)-(bmInfo.bmWidth/2), (wharfs[i].height/2)-(bmInfo.bmHeight/2), bmInfo.bmWidth, bmInfo.bmHeight, src, 0, 0, RGB(255,0,255));
			DeleteObject(wharfs[i].subwharfs[x].subwharfs2[z].frontImage);
		}
		
		ReleaseDC(wharfs[i].subwharfs[x].subwharfs2[z].hWnd, tempDC);
		DeleteDC(src);
		DeleteDC(dst);
		DeleteObject(hb);
	}
	
	if (wharfs[i].subwharfs[x].subwharfs2[z].backImage && !wharfs[i].subwharfs[x].subwharfs2[z].hInst)
	{
		HRGN wharfRgn;
		
		if(wharfs[i].vertical)
			wharfRgn = BitmapToRegion(wharfs[i].subwharfs[x].subwharfs2[z].backImage, RGB(255,0,255), 0x101010, (wharfs[i].width*z), 0);
		else
			wharfRgn = BitmapToRegion(wharfs[i].subwharfs[x].subwharfs2[z].backImage, RGB(255,0,255), 0x101010, 0, (wharfs[i].height*z));
		
		if (CombineRgn(wharfs[i].subwharfs[x].subRgn, wharfs[i].subwharfs[x].subRgn, wharfRgn, RGN_OR) == ERROR)
			wharfs[i].subwharfs[x].subRgn = wharfRgn;
		else
			DeleteObject(wharfRgn);
	}
	else
	{
		HRGN rgn, bgRgn;
		if (wharfs[i].subwharfs[x].subwharfs2[z].GetLSRegion)
		{
			if(wharfs[i].vertical)
			{
				bgRgn = BitmapToRegion(wharfs[i].subwharfs[x].subwharfs2[z].backImage, RGB(255,0,255), 0x101010, (wharfs[i].width*z), 0);
				rgn = wharfs[i].subwharfs[x].subwharfs2[z].GetLSRegion(wharfs[i].width*z, 0);
			}
			else
			{
				bgRgn = BitmapToRegion(wharfs[i].subwharfs[x].subwharfs2[z].backImage, RGB(255,0,255), 0x101010, 0, (wharfs[i].height*z));
				rgn = wharfs[i].subwharfs[x].subwharfs2[z].GetLSRegion(0, wharfs[i].height*z);
			}
			if (rgn)
			{
				CombineRgn(rgn, rgn, bgRgn, RGN_OR);
				DeleteObject(bgRgn);
			}
			else
			{
				rgn = bgRgn;
			}

		}
		else
		{
			if(wharfs[i].vertical)
				rgn = CreateRectRgn(wharfs[i].width*z, 0, wharfs[i].width*(z+1), wharfs[i].height);
			else
				rgn = CreateRectRgn(0, wharfs[i].height*z, wharfs[i].width, wharfs[i].height*(z+1));
		}
		
		if (CombineRgn(wharfs[i].subwharfs[x].subRgn, wharfs[i].subwharfs[x].subRgn, rgn, RGN_OR) == ERROR)
			wharfs[i].subwharfs[x].subRgn = rgn;
		else
			DeleteObject(rgn);
	}
	
	ShowWindow(wharfs[i].subwharfs[x].subwharfs2[z].hWnd, SW_SHOWNORMAL);
	
	return TRUE;
}

int GetWharfByWnd(HWND hwnd)
{
	int i;
	
	for (i=0;i<numWharfs;i++)
		if (wharfs[i].hWnd == hwnd)
			return i;
		return -1;
}

void GetWharfData(wharfDataType *wd)
{
		
	strcpy(lsPath, szLitestepPath);
	if (lsPath[strlen(lsPath)] != '\\')
		strcat(lsPath, "\\");

	wd->trayIconSize = GetRCInt("TrayIconSize", 16);
	wd->taskBarFore = GetRCColor("LSTaskBarFore", 0x000000);
	wd->taskBarBack = GetRCColor("LSTaskBarBack", 0x7f7f7f);
	wd->taskBarText = GetRCColor("LSTaskBarText", 0xffffff);
	wd->taskBarFore2 = GetRCColor("LSTaskBarFore2", 0x3f3f3f3f);
	wd->taskBar = GetRCBool("NoTaskBar", FALSE);
	wd->showBeta = GetRCBool("NoShowBeta", TRUE);;
	wd->usClock = GetRCBool("UsClock", TRUE);
	wd->vwmVelocity = GetRCInt("VWMVelocity", 300);
	wd->VWMDistance = GetRCInt("VWMSecurityDistance", 5);
	wd->VWMNoAuto = GetRCBool("VWMNoAuto", TRUE);
	wd->pixmapDir = szImagePath;
	wd->defaultBmp = szDefPixmap;
	wd->vwmBackColor = GetRCColor("VWMBackColor", 0x000000);
	wd->vwmSelBackColor = GetRCColor("VWMSelBackColor", 0x3f3f3f);
	wd->vwmForeColor = GetRCColor("VWMForeColor", 0x906090);
	wd->vwmBorderColor = GetRCColor("VWMBorderColor", 0xffffff);
	wd->lsPath = lsPath;
	wd->borderSize = 0;
}

void ExecuteWharf(int i)
{
	int q;
	if (!strcmpi(wharfs[i].szCommand, "Folder"))
	{
		if (wharfs[i].moving) 
		{
			if (wharfs[i].closing) 
				wharfs[i].closing = FALSE;
			else
				wharfs[i].closing = TRUE;
		} else if (wharfs[i].subwharfOpen == FALSE) {
			wharfs[i].subwharfOpen = TRUE;
			if (wharfNoAnim)
			{
				if(wharfs[i].vertical)
				{
					if ((wharfs[i].yPos+wharfs[i].height/2) > ScreenWidth/2)
						SetWindowPos(wharfs[i].hsubwharfWnd, 0, wharfs[i].xPos, wharfs[i].yPos-(wharfs[i].numSubwharfs*wharfs[i].height), wharfs[i].width, wharfs[i].numSubwharfs*wharfs[i].height, SWP_NOZORDER);
					else
						SetWindowPos(wharfs[i].hsubwharfWnd, 0, wharfs[i].xPos, wharfs[i].yPos+wharfs[i].height, wharfs[i].width, wharfs[i].numSubwharfs*wharfs[i].height, SWP_NOZORDER);
				}
				else
				{
					if ((wharfs[i].xPos+wharfs[i].width/2) > ScreenWidth/2)
						SetWindowPos(wharfs[i].hsubwharfWnd, 0, wharfs[i].xPos-(wharfs[i].numSubwharfs*wharfs[i].width), wharfs[i].yPos, wharfs[i].numSubwharfs*wharfs[i].width, wharfs[i].height, SWP_NOZORDER);
					else
						SetWindowPos(wharfs[i].hsubwharfWnd, 0, wharfs[i].xPos+wharfs[i].width, wharfs[i].yPos, wharfs[i].numSubwharfs*wharfs[i].width, wharfs[i].height, SWP_NOZORDER);
				}
			} else {
				wharfs[i].moving = TRUE;
				wharfs[i].closing = FALSE;
				SetTimer(wharfs[i].hsubwharfWnd, 2, wharfAnimTime, NULL);
				OpenFolders++;
			}
		} else if (wharfs[i].subwharfOpen) {
			if (wharfNoAnim)
			{
				wharfs[i].subwharfOpen = FALSE;
				CloseSubFolders(i);
				SetWindowPos(wharfs[i].hsubwharfWnd, 0, 0, 0, 0, 0, SWP_NOZORDER);
			} else {
				wharfs[i].moving = TRUE;
				wharfs[i].closing = TRUE;
				SetTimer(wharfs[i].hsubwharfWnd, 3, wharfAnimTime, NULL);
				OpenFolders--;
			}
		}
		return;
	}

	if (wharfs[i].szCommand[0] == '@')
	{
		wharfDataType wharfData;
		memset (&wharfData, 0, sizeof (wharfData));
		GetWharfData(&wharfData);
		
		(*wharfs[i].initWharfModule)(wharfs[i].hWnd, wharfs[i].hInst, &wharfData);
		return;
	}
	
	if (wharfs[i].szCommand[0] == '!')
	{
		ParseBangCommand(wharfs[i].hWnd, wharfs[i].szCommand, wharfs[i].szParameters);
		return;
	}
	
	{
		SHELLEXECUTEINFO si;
		char workDirectory[MAX_PATH];
		char drive[_MAX_DRIVE];
		char dir[_MAX_DIR];
		
		_splitpath(wharfs[i].szCommand, drive, dir, NULL, NULL);
		strcpy(workDirectory, drive);
		strcat(workDirectory, dir);
		
		memset(&si, 0, sizeof(si));
		si.cbSize = sizeof(SHELLEXECUTEINFO);
		si.lpDirectory = workDirectory;
		si.lpVerb = NULL;
		si.nShow = 1;
		si.fMask = SEE_MASK_DOENVSUBST;
		si.lpFile = wharfs[i].szCommand;
		si.lpParameters = wharfs[i].szParameters;
		ShellExecuteEx(&si);
		return;
	}
}

void ExecuteSubWharf(int i, int x)
{
	int q, t;
	if (!strcmpi(wharfs[i].subwharfs[x].szCommand, "Folder"))
	{
		if (wharfs[i].subwharfs[x].moving) 
		{
			if (wharfs[i].subwharfs[x].closing) 
				wharfs[i].subwharfs[x].closing = FALSE;
			else
				wharfs[i].subwharfs[x].closing = TRUE;
		} else if (wharfs[i].subwharfs[x].subwharfOpen == FALSE) {
			wharfs[i].subwharfs[x].subwharfOpen = TRUE;
			if (wharfNoAnim)
			{
				if(wharfs[i].vertical)
				{
					if ((wharfs[i].xPos+wharfs[i].width/2) > ScreenWidth/2)
					{
						if((wharfs[i].yPos+wharfs[i].height/2) > ScreenHeight/2)
							SetWindowPos(wharfs[i].subwharfs[x].hsubwharfWnd, 0, wharfs[i].xPos-(wharfs[i].subwharfs[x].numSubwharfs*wharfs[i].width), wharfs[i].yPos-((wharfs[i].numSubwharfs-x)*wharfs[i].height), wharfs[i].subwharfs[x].numSubwharfs*wharfs[i].width, wharfs[i].height, SWP_NOZORDER);
						else
							SetWindowPos(wharfs[i].subwharfs[x].hsubwharfWnd, 0, wharfs[i].xPos-(wharfs[i].subwharfs[x].numSubwharfs*wharfs[i].width), wharfs[i].yPos+((x+1)*wharfs[i].height), wharfs[i].subwharfs[x].numSubwharfs*wharfs[i].width, wharfs[i].height, SWP_NOZORDER);
					}
					else
					{
						if((wharfs[i].yPos+wharfs[i].height/2) > ScreenHeight/2)
							SetWindowPos(wharfs[i].subwharfs[x].hsubwharfWnd, 0, wharfs[i].xPos+wharfs[i].width, wharfs[i].yPos-((wharfs[i].numSubwharfs-x)*wharfs[i].height), wharfs[i].subwharfs[x].numSubwharfs*wharfs[i].width, wharfs[i].height, SWP_NOZORDER);
						else
							SetWindowPos(wharfs[i].subwharfs[x].hsubwharfWnd, 0, wharfs[i].xPos+wharfs[i].width, wharfs[i].yPos+((x+1)*wharfs[i].height), wharfs[i].subwharfs[x].numSubwharfs*wharfs[i].width, wharfs[i].height, SWP_NOZORDER);
					}
				}
				else
				{
					if ((wharfs[i].xPos+wharfs[i].width/2) > ScreenWidth/2)
					{
						if((wharfs[i].yPos+wharfs[i].height/2) > ScreenHeight/2)
							SetWindowPos(wharfs[i].subwharfs[x].hsubwharfWnd, 0, wharfs[i].xPos-((wharfs[i].numSubwharfs-x)*wharfs[i].width), wharfs[i].yPos-(wharfs[i].subwharfs[x].numSubwharfs*wharfs[i].height), wharfs[i].width, wharfs[i].subwharfs[x].numSubwharfs*wharfs[i].height, SWP_NOZORDER);
						else
							SetWindowPos(wharfs[i].subwharfs[x].hsubwharfWnd, 0, wharfs[i].xPos-((wharfs[i].numSubwharfs-x)*wharfs[i].width), wharfs[i].yPos+wharfs[i].height, wharfs[i].width, wharfs[i].subwharfs[x].numSubwharfs*wharfs[i].height, SWP_NOZORDER);
					}
					else
					{
						if((wharfs[i].yPos+wharfs[i].height/2) > ScreenHeight/2)
							SetWindowPos(wharfs[i].subwharfs[x].hsubwharfWnd, 0, wharfs[i].xPos+((x+1)*wharfs[i].width), wharfs[i].yPos-(wharfs[i].subwharfs[x].numSubwharfs*wharfs[i].height), wharfs[i].width, wharfs[i].subwharfs[x].numSubwharfs*wharfs[i].height, SWP_NOZORDER);
						else
							SetWindowPos(wharfs[i].subwharfs[x].hsubwharfWnd, 0, wharfs[i].xPos+((x+1)*wharfs[i].width), wharfs[i].yPos+wharfs[i].height, wharfs[i].width, wharfs[i].subwharfs[x].numSubwharfs*wharfs[i].height, SWP_NOZORDER);
					}
				}
			} else {
				wharfs[i].subwharfs[x].moving = TRUE;
				wharfs[i].subwharfs[x].closing = FALSE;
				SetTimer(wharfs[i].subwharfs[x].hsubwharfWnd, 5, wharfAnimTime, NULL);
				OpenFolders2++;
			}
		} else if (wharfs[i].subwharfs[x].subwharfOpen) {
			if (wharfNoAnim)
			{
				wharfs[i].subwharfs[x].subwharfOpen = FALSE;
				SetWindowPos(wharfs[i].subwharfs[x].hsubwharfWnd, 0, 0, 0, 0, 0, SWP_NOZORDER);
			} else {
				wharfs[i].subwharfs[x].moving = TRUE;
				wharfs[i].subwharfs[x].closing = TRUE;
				SetTimer(wharfs[i].subwharfs[x].hsubwharfWnd, 6, wharfAnimTime, NULL);
				OpenFolders2--;
			}
		}
		return;
	}

	if (wharfs[i].subwharfs[x].szCommand[0] == '@')
	{
		wharfDataType wharfData;
		char lsPath[256];
		
		strcpy(lsPath, szLitestepPath);
		if (lsPath[strlen(lsPath)] != '\\')
			strcat(lsPath, "\\");
		memset (&wharfData, 0, sizeof (wharfData));
		GetWharfData(&wharfData);
		
		(*wharfs[i].subwharfs[x].initWharfModule)(wharfs[i].subwharfs[x].hWnd, wharfs[i].subwharfs[x].hInst, &wharfData);
		return;
	}
	
	if (wharfs[i].subwharfs[x].szCommand[0] == '!')
	{
		ParseBangCommand(wharfs[i].hsubwharfWnd, wharfs[i].subwharfs[x].szCommand, wharfs[i].subwharfs[x].szParameters);
		return;
	}
	
	{
		SHELLEXECUTEINFO si;
		char workDirectory[MAX_PATH];
		char drive[_MAX_DRIVE];
		char dir[_MAX_DIR];
		
		_splitpath(wharfs[i].subwharfs[x].szCommand, drive, dir, NULL, NULL);
		strcpy(workDirectory, drive);
		strcat(workDirectory, dir);
		memset(&si, 0, sizeof(si));
		si.cbSize = sizeof(SHELLEXECUTEINFO);
		si.lpDirectory = workDirectory;
		si.lpVerb = NULL;
		si.nShow = 1;
		si.fMask = SEE_MASK_DOENVSUBST;
		si.lpFile = wharfs[i].subwharfs[x].szCommand;
		si.lpParameters = wharfs[i].subwharfs[x].szParameters;
		ShellExecuteEx(&si);
		return;
	}
}

void ExecuteSubWharf2(int i, int x, int z)
{
	if (wharfs[i].subwharfs[x].subwharfs2[z].szCommand[0] == '@')
	{
		wharfDataType wharfData;
		char lsPath[256];
		
		strcpy(lsPath, szLitestepPath);
		if (lsPath[strlen(lsPath)] != '\\')
			strcat(lsPath, "\\");
		memset (&wharfData, 0, sizeof (wharfData));
		GetWharfData(&wharfData);
		
		(*wharfs[i].subwharfs[x].subwharfs2[z].initWharfModule)(wharfs[i].subwharfs[x].subwharfs2[z].hWnd, wharfs[i].subwharfs[x].subwharfs2[z].hInst, &wharfData);
		return;
	}
	
	if (wharfs[i].subwharfs[x].subwharfs2[z].szCommand[0] == '!')
	{
		ParseBangCommand(wharfs[i].subwharfs[x].hsubwharfWnd, wharfs[i].subwharfs[x].subwharfs2[z].szCommand, wharfs[i].subwharfs[x].subwharfs2[z].szParameters);
		return;
	}
	
	{
		SHELLEXECUTEINFO si;
		char workDirectory[MAX_PATH];
		char drive[_MAX_DRIVE];
		char dir[_MAX_DIR];
		
		_splitpath(wharfs[i].subwharfs[x].subwharfs2[z].szCommand, drive, dir, NULL, NULL);
		strcpy(workDirectory, drive);
		strcat(workDirectory, dir);
		memset(&si, 0, sizeof(si));
		si.cbSize = sizeof(SHELLEXECUTEINFO);
		si.lpDirectory = workDirectory;
		si.lpVerb = NULL;
		si.nShow = 1;
		si.fMask = SEE_MASK_DOENVSUBST;
		si.lpFile = wharfs[i].subwharfs[x].subwharfs2[z].szCommand;
		si.lpParameters = wharfs[i].subwharfs[x].subwharfs2[z].szParameters;
		ShellExecuteEx(&si);
		return;
	}
}

void CreateWharfhints(HWND hWnd, char *txt, RECT *r) {
	TOOLINFO ti;    // tool information

	if (wharfNoHints)
	{
		return;
	}

	ti.cbSize = sizeof(TOOLINFO);
	ti.uFlags = TTF_SUBCLASS;
	ti.hwnd = hWnd;
	ti.hinst = dll;
	ti.uId = 0;
	ti.lpszText = txt;
	ti.rect = *r;

	SendMessage(wharfHints, TTM_ADDTOOL, 0, (LPARAM) (LPTOOLINFO) &ti);
}

void RemoveWharfhints(HWND hWnd) {
	TOOLINFO ti;    // tool information
	RECT r={0,0,0,0};

	ti.cbSize = sizeof(TOOLINFO);
	ti.uFlags = 0;
	ti.hwnd = hWnd;
	ti.hinst = dll;
	ti.uId = 0;
	ti.lpszText = NULL;
	ti.rect = r;

	SendMessage(wharfHints, TTM_DELTOOL, 0, (LPARAM) (LPTOOLINFO) &ti);
}

void ToggleShow(HWND caller, char* arg)
{
	int i, g;

	g = atoi(arg);

	CloseAllFolders();

	for(i = 0; i < numWharfs; i++)
		if(wharfs[i].group == g)
			if(wharfs[i].visible)
			{
				wharfs[i].visible = FALSE;
				ShowWindow(wharfs[i].hWnd, SW_HIDE);
			}
			else
			{
				wharfs[i].visible = TRUE;
				ShowWindow(wharfs[i].hWnd, SW_SHOW);
			}
}

void ToggleOnTop(HWND caller, char* arg)
{
	int i, g;

	g = atoi(arg);

	for(i = 0; i < numWharfs; i++)
		if(wharfs[i].group == g)
			if(wharfs[i].onTop)
			{
				wharfs[i].onTop = FALSE;
				SetWindowPos(wharfs[i].hWnd, HWND_NOTOPMOST, wharfs[i].xPos, wharfs[i].yPos, 0, 0, SWP_NOMOVE|SWP_NOSIZE);
			}
			else
			{
				wharfs[i].onTop = TRUE;
				SetWindowPos(wharfs[i].hWnd, HWND_TOPMOST, wharfs[i].xPos, wharfs[i].yPos, 0, 0, SWP_NOMOVE|SWP_NOSIZE);
			}
}

void ToggleDrag(HWND caller, char* arg)
{
	if(wharfDrag)
		wharfDrag = FALSE;
	else
		wharfDrag = TRUE;
}

void DockToWindow(int i)
{
	if(IsAppWindow(activeWnd))
	{
		ShowWindow(wharfs[i].hWnd, SW_SHOW);
		SetWindowPos(wharfs[i].hWnd, HWND_TOPMOST, *p + wharfs[i].dockPoint.x + dockOffsetX, *q + wharfs[i].dockPoint.y + dockOffsetY, 0, 0, SWP_NOSIZE);
	}
	else
	{
		ShowWindow(wharfs[i].hWnd, SW_HIDE);
	}
	return;
}

//This function is from Re5ource's popup
BOOL IsAppWindow(HWND hWnd)
{
	BOOL bResult = TRUE;
	LONG nStyle;
	HWND hOwner;
	HWND hParent;

	// if it is a WS_CHILD or not WS_VISIBLE, fail it
	nStyle = GetWindowLong(hWnd, GWL_STYLE);	
	if((nStyle & WS_CHILD) || !(nStyle & WS_VISIBLE))
		bResult = FALSE;

	// if the window is a WS_EX_TOOLWINDOW fail it
	nStyle = GetWindowLong(hWnd, GWL_EXSTYLE);
	if(nStyle & WS_EX_TOOLWINDOW)
		bResult = FALSE;

	// If this has an owner, then only accept this window
	// if the partent is not accepted
	hOwner = GetWindow(hWnd, GW_OWNER);
	if(hOwner && bResult)
		bResult = !IsAppWindow(hOwner);

	// if it has a parent, fail
	hParent = GetParent(hWnd);
	if(hParent)
		bResult = FALSE;

	if(GetWindowLong(hWnd, GWL_USERDATA) == 0x49474541)
		bResult = FALSE;

	return bResult;
}